Index: trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj	(revision 11365)
+++ trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/HeuristicLab.Services.Hive.JanitorService-3.3.csproj	(revision 11366)
@@ -135,7 +135,12 @@
     </EmbeddedResource>
   </ItemGroup>
+  <ItemGroup>
+    <Content Include="ICSharpCode.SharpZipLib License.txt">
+      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
+    </Content>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -143,5 +148,5 @@
 
 call PreBuildEvent.cmd</PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/ICSharpCode.SharpZipLib License.txt
===================================================================
--- trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/ICSharpCode.SharpZipLib License.txt	(revision 11366)
+++ trunk/sources/HeuristicLab.Services.Hive.JanitorService/3.3/ICSharpCode.SharpZipLib License.txt	(revision 11366)
@@ -0,0 +1,13 @@
+#ziplib (SharpZipLib, formerly NZipLib) is a Zip, GZip, Tar and BZip2 library written entirely in C# for the .NET platform. It is implemented as an assembly (installable in the GAC), and thus can easily be incorporated into other projects (in any .NET language). The creator of #ziplib put it this way: "I've ported the zip library over to C# because I needed gzip/zip compression and I didn't want to use libzip.dll or something like this. I want all in pure C#."
+
+License
+
+The library is released under the GPL with the following exception:
+
+Linking this library statically or dynamically with other modules is making a combined work based on this library. Thus, the terms and conditions of the GNU General Public License cover the whole combination.
+
+As a special exception, the copyright holders of this library give you permission to link this library with independent modules to produce an executable, regardless of the license terms of these independent modules, and to copy and distribute the resulting executable under terms of your choice, provided that you also meet, for each linked independent module, the terms and conditions of the license of that module. An independent module is a module which is not derived from or based on this library. If you modify this library, you may extend this exception to your version of the library, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.
+
+Note: The exception is changed to reflect the latest GNU Classpath exception. Older versions of #ziplib did have another exception, but the new one is clearer and it doesn't break compatibility with the old one.
+
+Bottom line: In plain English this means you can use this library in commercial closed-source applications.
Index: trunk/sources/Installers/HiveJanitorServiceInstaller.nsi
===================================================================
--- trunk/sources/Installers/HiveJanitorServiceInstaller.nsi	(revision 11366)
+++ trunk/sources/Installers/HiveJanitorServiceInstaller.nsi	(revision 11366)
@@ -0,0 +1,79 @@
+; NSIS installer script for HeuristicLab Hive Janitor Service
+; NSIS version: v3.0b0
+
+Name "HeuristicLab Hive Janitor Service"
+OutFile "HeuristicLab Hive Janitor Service Installer.exe"
+
+; Build configuration is either Debug or Release
+!define BUILDCONFIGURATION "Debug"
+!define JANITORBUILDPATH "..\HeuristicLab.Services.Hive.JanitorService\3.3\bin\${BUILDCONFIGURATION}"
+
+InstallDir $PROGRAMFILES\HeuristicLabHiveJanitorService
+InstallDirRegKey HKLM "Software\HeuristicLabHiveJanitorService" "Install_Dir"
+
+RequestExecutionLevel admin
+
+Page license
+Page directory
+Page instfiles
+
+UninstPage uninstConfirm
+UninstPage instfiles
+
+LicenseData "..\HeuristicLab\3.3\GNU General Public License.txt"
+Icon "..\HeuristicLab\3.3\HeuristicLab.ico"
+
+
+Section "HeuristicLabHiveJanitorService (required)"
+	SetOutPath $INSTDIR
+
+	File "${JANITORBUILDPATH}\GeoIP.dat"
+	File "${JANITORBUILDPATH}\HeuristicLab.Common-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Persistence-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.PluginInfrastructure-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Access.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Hive.DataAccess-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Hive.JanitorService-3.3.exe"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Hive.JanitorService-3.3.exe.config"
+	File "${JANITORBUILDPATH}\HeuristicLab.Services.Hive-3.3.dll"
+	File "${JANITORBUILDPATH}\HeuristicLab.Tracing-3.3.dll"
+	File "${JANITORBUILDPATH}\ICSharpCode.SharpZipLib License.txt"
+	File "${JANITORBUILDPATH}\ICSharpCode.SharpZipLib.dll"
+
+	WriteRegStr HKLM SOFTWARE\HeuristicLabHiveJanitorService "Install_Dir" "$INSTDIR"
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "DisplayName" "HeuristicLabHiveJanitorService"
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "UninstallString" '"$INSTDIR\uninstall.exe"'
+	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "NoModify" 1
+	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService" "NoRepair" 1
+	WriteUninstaller "uninstall.exe"
+
+	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Services.Hive.JanitorService-3.3.exe" --install'
+
+SectionEnd
+
+
+Section "un.Uninstall"  
+	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveJanitorService"
+	DeleteRegKey HKLM SOFTWARE\HeuristicLabHiveJanitorService
+	  
+	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Services.Hive.JanitorService-3.3.exe" --uninstall'
+	  
+	Delete "$INSTDIR\GeoIP.dat"
+	Delete "$INSTDIR\HeuristicLab.Common-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.Persistence-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.PluginInfrastructure-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.Services.Access.dll"
+	Delete "$INSTDIR\HeuristicLab.Services.Hive.DataAccess-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.Services.Hive.JanitorService-3.3.exe"
+	Delete "$INSTDIR\HeuristicLab.Services.Hive.JanitorService-3.3.exe.config"
+	Delete "$INSTDIR\HeuristicLab.Services.Hive-3.3.dll"
+	Delete "$INSTDIR\HeuristicLab.Tracing-3.3.dll"
+	Delete "$INSTDIR\ICSharpCode.SharpZipLib License.txt"
+	Delete "$INSTDIR\ICSharpCode.SharpZipLib.dll"    
+	Delete "$INSTDIR\uninstall.exe"
+
+	RMDir "$INSTDIR"
+
+SectionEnd
+
+
Index: trunk/sources/Installers/HiveSlaveInstaller.nsi
===================================================================
--- trunk/sources/Installers/HiveSlaveInstaller.nsi	(revision 11365)
+++ trunk/sources/Installers/HiveSlaveInstaller.nsi	(revision 11366)
@@ -26,35 +26,35 @@
 
 Section "HeuristicLabHiveSlave (required)"
-SetOutPath $INSTDIR
+	SetOutPath $INSTDIR
 
-File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.Slave.WindowsService.exe"
-File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Common-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.Slave.WindowsService.exe.config"
-File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.SlaveCore-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Collections-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Common.Resources-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Common-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Core-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Data-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Hive-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.MainForm-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Optimization-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Parameters-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Persistence-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.PluginInfrastructure-3.3.dll"
-File "${SLAVEBUILDPATH}\HeuristicLab.Tracing-3.3.dll"
-File "${SLAVEBUILDPATH}\ICSharpCode.SharpZipLib License.txt"
-File "${SLAVEBUILDPATH}\ICSharpCode.SharpZipLib.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.Slave.WindowsService.exe"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Common-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.Slave.WindowsService.exe.config"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive.SlaveCore-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Clients.Hive-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Collections-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Common.Resources-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Common-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Core-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Data-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Hive-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.MainForm-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Optimization-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Parameters-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Persistence-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.PluginInfrastructure-3.3.dll"
+	File "${SLAVEBUILDPATH}\HeuristicLab.Tracing-3.3.dll"
+	File "${SLAVEBUILDPATH}\ICSharpCode.SharpZipLib License.txt"
+	File "${SLAVEBUILDPATH}\ICSharpCode.SharpZipLib.dll"
 
 
-WriteRegStr HKLM SOFTWARE\HeuristicLabHiveSlave "Install_Dir" "$INSTDIR"
-WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "DisplayName" "HeuristicLabHiveSlave"
-WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "UninstallString" '"$INSTDIR\uninstall.exe"'
-WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "NoModify" 1
-WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "NoRepair" 1
-WriteUninstaller "uninstall.exe"
+	WriteRegStr HKLM SOFTWARE\HeuristicLabHiveSlave "Install_Dir" "$INSTDIR"
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "DisplayName" "HeuristicLabHiveSlave"
+	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "UninstallString" '"$INSTDIR\uninstall.exe"'
+	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "NoModify" 1
+	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave" "NoRepair" 1
+	WriteUninstaller "uninstall.exe"
 
-nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe" --install'
+	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe" --install'
 
 SectionEnd
@@ -62,31 +62,31 @@
 
 Section "un.Uninstall"  
-  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave"
-  DeleteRegKey HKLM SOFTWARE\HeuristicLabHiveSlave
-  
-  nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe" --uninstall'
-      
-  Delete $INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe
-  Delete $INSTDIR\HeuristicLab.Clients.Common-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe.config
-  Delete $INSTDIR\HeuristicLab.Clients.Hive.SlaveCore-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Clients.Hive-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Collections-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Common.Resources-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Common-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Core-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Data-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Hive-3.3.dll
-  Delete $INSTDIR\HeuristicLab.MainForm-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Optimization-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Parameters-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Persistence-3.3.dll
-  Delete $INSTDIR\HeuristicLab.PluginInfrastructure-3.3.dll
-  Delete $INSTDIR\HeuristicLab.Tracing-3.3.dll
-  Delete "$INSTDIR\ICSharpCode.SharpZipLib License.txt"
-  Delete $INSTDIR\ICSharpCode.SharpZipLib.dll
-  Delete $INSTDIR\uninstall.exe
+	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\HeuristicLabHiveSlave"
+	DeleteRegKey HKLM SOFTWARE\HeuristicLabHiveSlave
 
-  RMDir "$INSTDIR"
+	nsExec::ExecToLog '"$INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe" --uninstall'
+	  
+	Delete $INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe
+	Delete $INSTDIR\HeuristicLab.Clients.Common-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Clients.Hive.Slave.WindowsService.exe.config
+	Delete $INSTDIR\HeuristicLab.Clients.Hive.SlaveCore-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Clients.Hive-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Collections-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Common.Resources-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Common-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Core-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Data-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Hive-3.3.dll
+	Delete $INSTDIR\HeuristicLab.MainForm-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Optimization-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Parameters-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Persistence-3.3.dll
+	Delete $INSTDIR\HeuristicLab.PluginInfrastructure-3.3.dll
+	Delete $INSTDIR\HeuristicLab.Tracing-3.3.dll
+	Delete "$INSTDIR\ICSharpCode.SharpZipLib License.txt"
+	Delete $INSTDIR\ICSharpCode.SharpZipLib.dll
+	Delete $INSTDIR\uninstall.exe
+
+	RMDir "$INSTDIR"
 
 SectionEnd